#include <stdio.h>
#include <math.h>

int power(int a, int b, int mod)
{
    int result = 1;
    a = a % mod;
    while (b > 0)
    {
        if (b & 1)
        {
            result = (result * a) % mod;
        }
        b = b >> 1;
        a = (a * a) % mod;
    }
    return result;
}

void diffieHellman(int prime, int primitiveRoot)
{
    int alicePrivate = 6;
    int bobPrivate = 15;
    int alicePublic = power(primitiveRoot, alicePrivate, prime);
    int bobPublic = power(primitiveRoot, bobPrivate, prime);

    int aliceSecret = power(bobPublic, alicePrivate, prime);
    int bobSecret = power(alicePublic, bobPrivate, prime);

    printf("\n Prime: %d, Primitive Root: %d\n", prime, primitiveRoot);
    printf("\n Alice private key: %d, Bob private key: %d\n", alicePrivate, bobPrivate);
    printf("\n Alice public key: %d, Bob public key: %d\n", alicePublic, bobPublic);
    printf("\n Shared Secret key (Alice): %d, Shared Secret key (Bob): %d\n\n", aliceSecret, bobSecret);
}

int main()
{
    int prime = 23;
    int primitiveRoot = 5;
    diffieHellman(prime, primitiveRoot);
    return 0;
}
